
package de.ivu.elect.presentation.search.table;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Named;

import de.ivu.elect.business.search.entity.AbstractBenutzerSuchparameter;
import de.ivu.elect.business.search.entity.BenutzerSuchparameter;
import de.ivu.elect.jee.presentation.dynamictable.AbstractColumnBuilder;
import de.ivu.elect.jee.presentation.dynamictable.ColumnEntry;
import de.ivu.elect.jee.presentation.dynamictable.ColumnType;

@Named(BenutzerSuchparameterColumnBuilder.COMPONENT_NAME)
public class BenutzerSuchparameterColumnBuilder extends AbstractColumnBuilder<BenutzerSuchparameter> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "benutzerSuchparameterColumnBuilder";

  private AbstractBenutzerSuchparameterColumn<BenutzerSuchparameter> benutzerSuchparameterNameColumn;

  private AbstractBenutzerSuchparameterColumn<BenutzerSuchparameter> benutzerSuchparameterViewIdColumn;

  private AbstractBenutzerSuchparameterColumn<BenutzerSuchparameter> benutzerSuchparameterAlsDefaultColumn;

  public BenutzerSuchparameterColumnBuilder() {
    super();
  }

  @Override
  protected void initColumns() {
    benutzerSuchparameterNameColumn = AbstractBenutzerSuchparameterColumn.createBenutzerSuchparameterNameColumn(getMessages());
    benutzerSuchparameterViewIdColumn = AbstractBenutzerSuchparameterColumn.createBenutzerSuchparameterViewIdColumn(getMessages());
    benutzerSuchparameterAlsDefaultColumn = new AbstractBenutzerSuchparameterColumn<>("BenutzerSuchparameter-AlsDefault", getMessages(), "entity.einzahl.BENUTZER_SUCHPARAMETER.ALS_DEFAULT",
        ColumnType.BOOLEAN, AbstractBenutzerSuchparameter::isSuchparameterAlsDefault);
  }

  @Override
  protected List<ColumnEntry< ? super BenutzerSuchparameter>> getColumnEntriesSorted() {
    List<ColumnEntry< ? super BenutzerSuchparameter>> result = new ArrayList<>();

    result.add(benutzerSuchparameterNameColumn);
    result.add(benutzerSuchparameterViewIdColumn);
    result.add(benutzerSuchparameterAlsDefaultColumn);

    return result;
  }
}
